import { CodeSnippet, LangSlug, ProblemDifficulty, ProblemStatus } from "../utils/interfaces";
import Submission from "./submission";
declare class Problem {
    readonly slug: string;
    id?: number | undefined;
    title?: string | undefined;
    difficulty?: ProblemDifficulty | undefined;
    starred?: boolean | undefined;
    locked?: boolean | undefined;
    likes?: number | undefined;
    dislikes?: number | undefined;
    status?: ProblemStatus | undefined;
    tag?: string[] | undefined;
    totalAccepted?: number | undefined;
    totalSubmission?: number | undefined;
    hints?: string[] | undefined;
    sampleTestCase?: string | undefined;
    exampleTestcases?: string | undefined;
    content?: string | undefined;
    translatedContent?: string | undefined;
    translatedTitle?: string | undefined;
    codeSnippets?: CodeSnippet[] | undefined;
    constructor(slug: string, id?: number | undefined, title?: string | undefined, difficulty?: ProblemDifficulty | undefined, starred?: boolean | undefined, locked?: boolean | undefined, likes?: number | undefined, dislikes?: number | undefined, status?: ProblemStatus | undefined, tag?: string[] | undefined, totalAccepted?: number | undefined, totalSubmission?: number | undefined, hints?: string[] | undefined, sampleTestCase?: string | undefined, exampleTestcases?: string | undefined, content?: string | undefined, translatedContent?: string | undefined, translatedTitle?: string | undefined, codeSnippets?: CodeSnippet[] | undefined);
    static build(slug: string): Promise<Problem>;
    detail(): Promise<Problem>;
    getContentImages(): Promise<{
        content: Map<string, string>;
        translatedContent: Map<string, string>;
    }>;
    getSubmissions(): Promise<Array<Submission>>;
    submit(langSlug: LangSlug, code: string): Promise<Submission>;
}
export default Problem;
