import Helper from "../utils/helper";
import Problem from "./problem";
class Contest {
    slug;
    contest;
    questions;
    user_num;
    has_chosen_contact;
    company;
    registered;
    containsPremium;
    static getWeeklyContestSlug(id) {
        return `weekly-contest-${id}`;
    }
    static getBiweeklyContestSlug(id) {
        return `biweekly-contest-${id}`;
    }
    constructor(slug, contest, questions, user_num, has_chosen_contact, company, registered, containsPremium) {
        this.slug = slug;
        this.contest = contest;
        this.questions = questions;
        this.user_num = user_num;
        this.has_chosen_contact = has_chosen_contact;
        this.company = company;
        this.registered = registered;
        this.containsPremium = containsPremium;
    }
    static async build(slug) {
        const contest = new Contest(slug);
        await contest.detail();
        return contest;
    }
    async detail() {
        let response = await Helper.HttpRequest({
            url: Helper.uris.contestInfo.replace("$slug", this.slug),
        });
        response = JSON.parse(response);
        this.contest = response.contest;
        this.questions = response.questions;
        this.user_num = response.user_num;
        this.has_chosen_contact = response.has_chosen_contact;
        this.company = response.company;
        this.registered = response.registered;
        this.containsPremium = response.containsPremium;
        return this;
    }
    async getProblems() {
        if (this.questions) {
            return Promise.all(this.questions.map(async (q) => {
                return await Problem.build(q.title_slug);
            }));
        }
        return [];
    }
}
export default Contest;
//# sourceMappingURL=contest.js.map